package org.processmining.acceptingpetrinetminer.connections;

import org.processmining.acceptingpetrinet.models.AcceptingPetriNetArray;
import org.processmining.acceptingpetrinetminer.parameters.DiscoverAcceptingPetriNetArrayFromEventLogArrayParameters;
import org.processmining.framework.connections.impl.AbstractConnection;
import org.processmining.log.models.EventLogArray;

public class DiscoverAcceptingPetriNetArrayFromEventLogArrayConnection extends AbstractConnection {

	public final static String LOGS = "Logs";
	public final static String NETS = "Nets";

	private DiscoverAcceptingPetriNetArrayFromEventLogArrayParameters parameters;

	public DiscoverAcceptingPetriNetArrayFromEventLogArrayConnection(EventLogArray logs,
			AcceptingPetriNetArray nets, DiscoverAcceptingPetriNetArrayFromEventLogArrayParameters parameters) {
		super("Discover Accepting Petri Net Array From Event Log Array Connection");
		put(LOGS, logs);
		put(NETS, nets);
		this.parameters = new DiscoverAcceptingPetriNetArrayFromEventLogArrayParameters(parameters);
	}

	public DiscoverAcceptingPetriNetArrayFromEventLogArrayParameters getParameters() {
		return parameters;
	}
}
