package org.processmining.acceptingpetrinetminer.dialogs;

import info.clearthought.layout.TableLayout;
import info.clearthought.layout.TableLayoutConstants;

import java.util.ArrayList;
import java.util.List;

import javax.swing.JPanel;

import org.deckfour.xes.classification.XEventAndClassifier;
import org.deckfour.xes.classification.XEventClassifier;
import org.deckfour.xes.classification.XEventLifeTransClassifier;
import org.deckfour.xes.classification.XEventNameClassifier;
import org.processmining.acceptingpetrinetminer.miners.DecomposedMiner;
import org.processmining.acceptingpetrinetminer.miners.DecomposedMinerManager;
import org.processmining.acceptingpetrinetminer.parameters.DiscoverAcceptingPetriNetArrayFromEventLogArrayParameters;
import org.processmining.log.dialogs.ClassifierPanel;
import org.processmining.log.dialogs.MinerPanel;
import org.processmining.log.models.EventLogArray;

public class DiscoverAcceptingPetriNetArrayFromEventLogArrayDialog extends JPanel {

	/**
	 * 
	 */
	private static final long serialVersionUID = 4544473255468256618L;

	public DiscoverAcceptingPetriNetArrayFromEventLogArrayDialog(EventLogArray logs,
			final DiscoverAcceptingPetriNetArrayFromEventLogArrayParameters parameters) {
		double size[][] = { { TableLayoutConstants.FILL }, { TableLayoutConstants.FILL, TableLayoutConstants.FILL/*, 30, 30*/ } };
		setLayout(new TableLayout(size));
		List<XEventClassifier> availableClassifiers = new ArrayList<XEventClassifier>();
		for (int i = 0; i < logs.getSize(); i++) {
			if (i == 0) {
				availableClassifiers.addAll(logs.getLog(i).getClassifiers());
			} else {
				availableClassifiers.retainAll(logs.getLog(i).getClassifiers());
			}
			if (availableClassifiers.isEmpty()) {
				availableClassifiers.add(new XEventAndClassifier(new XEventNameClassifier(),
						new XEventLifeTransClassifier()));
			}
		}
		add(new ClassifierPanel(availableClassifiers, parameters), "0, 0");
		List<String> availableMiners = new ArrayList<String>();
		for (DecomposedMiner miner: DecomposedMinerManager.getInstance().getMiners()) {
			availableMiners.add(miner.getName());
		}
		parameters.setMiner(DecomposedMinerManager.getInstance().getMiner(null).getName());
		add(new MinerPanel(availableMiners, parameters), "0, 1");

//		final JCheckBox removeBox = SlickerFactory.instance().createCheckBox("Make every net transition-bordered",
//				false);
//		removeBox.setSelected(parameters.isTransitionBordered());
//		removeBox.addActionListener(new ActionListener() {
//
//			public void actionPerformed(ActionEvent e) {
//				parameters.setTransitionBordered(removeBox.isSelected());
//			}
//
//		});
//		removeBox.setOpaque(false);
//		add(removeBox, "0, 2");
//
//		final JCheckBox gammaBox = SlickerFactory.instance().createCheckBox("Remove gamma transitions",
//				false);
//		gammaBox.setSelected(parameters.isRemoveGamma());
//		gammaBox.addActionListener(new ActionListener() {
//
//			public void actionPerformed(ActionEvent e) {
//				parameters.setRemoveGamma(gammaBox.isSelected());
//			}
//
//		});
//		gammaBox.setOpaque(false);
//		add(gammaBox, "0, 3");
	}
}