package org.processmining.acceptingpetrinetminer.miners;

import org.deckfour.xes.model.XLog;
import org.processmining.acceptingpetrinet.models.AcceptingPetriNet;
import org.processmining.framework.plugin.PluginContext;

public interface DecomposedMiner {
	
	/**
	 * Mines the given event log for an accepting Petri net.
	 * 
	 * @param context The current plug-in context.
	 * @param eventLog The event log, if requiresStartEndEvents() then with explicit |start> and [end] events, else without.
	 * @param parameters The parameters for the miner.
	 * @return The mined accepting Petri net.
	 */
	public AcceptingPetriNet mine(PluginContext context, XLog eventLog, DecomposedMinerParameters parameters);

	public String getName();
	
	public boolean requiresStartEndEvents();
}
