package org.processmining.acceptingpetrinetminer.miners;

import java.util.List;

import org.deckfour.xes.classification.XEventAndClassifier;
import org.deckfour.xes.classification.XEventClassifier;
import org.deckfour.xes.classification.XEventLifeTransClassifier;
import org.deckfour.xes.classification.XEventNameClassifier;
import org.deckfour.xes.model.XLog;
import org.processmining.activityclusterarray.models.ActivityClusterArray;

public class DecomposedMinerParameters {

	private XEventClassifier classifier;
	private int nrOfClusters;
	private ActivityClusterArray clusters;
	
	public DecomposedMinerParameters(XLog log) {
		List<XEventClassifier> classifiers = log.getClassifiers();
		if (!classifiers.isEmpty()) {
			setClassifier(classifiers.get(0));
		} else {
			setClassifier(new XEventAndClassifier(new XEventNameClassifier(), new XEventLifeTransClassifier()));
		}
		setNrOfClusters(1);
	}
	
	public XEventClassifier getClassifier() {
		return classifier;
	}
	
	public void setClassifier(XEventClassifier classifier) {
		this.classifier = classifier;
	}
	
	public int getNrOfClusters() {
		return nrOfClusters;
	}

	public void setNrOfClusters(int nrOfClusters) {
		this.nrOfClusters = nrOfClusters;
	}

	public ActivityClusterArray getClusters() {
		return clusters;
	}

	public void setClusters(ActivityClusterArray clusters) {
		this.clusters = clusters;
	}
}
