package org.processmining.acceptingpetrinetminer.miners.impl;

import org.deckfour.xes.model.XLog;
import org.processmining.acceptingpetrinetminer.miners.DecomposedImplicitMiner;
import org.processmining.acceptingpetrinetminer.miners.DecomposedMinerParameters;
import org.processmining.framework.connections.ConnectionCannotBeObtained;
import org.processmining.framework.packages.PackageManager;
import org.processmining.framework.packages.UnknownPackageException;
import org.processmining.framework.packages.UnknownPackageTypeException;
import org.processmining.framework.packages.impl.CancelledException;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.models.graphbased.directed.petrinet.Petrinet;
import org.processmining.plugins.InductiveMiner.mining.MiningParameters;

public abstract class DecomposedAbstractInductiveMiner implements DecomposedImplicitMiner {

	public Petrinet mineImplicit(PluginContext context, XLog eventLog, DecomposedMinerParameters parameters)
			throws CancelledException, UnknownPackageTypeException, UnknownPackageException, ConnectionCannotBeObtained {
		MiningParameters minerParameters = createParameters();
		minerParameters.setClassifier(parameters.getClassifier());
		setAdditionalParameters(minerParameters);
		PackageManager.getInstance().findOrInstallPackages("InductiveMiner");
		Petrinet pn = context.tryToFindOrConstructFirstNamedObject(Petrinet.class,
				"Mine Petri net with Inductive Miner, with parameters", null, null, eventLog, minerParameters);
		return pn;
	}

	public abstract MiningParameters createParameters(); 
	
	public abstract void setAdditionalParameters(MiningParameters minerParameters);
	
	public boolean requiresStartEndEvents() {
		return false;
	}
}
