package org.processmining.acceptingpetrinetminer.miners.impl;

import org.deckfour.xes.model.XLog;
import org.processmining.acceptingpetrinetminer.miners.DecomposedImplicitMiner;
import org.processmining.acceptingpetrinetminer.miners.DecomposedMinerParameters;
import org.processmining.alphaminer.plugins.AlphaMinerPlugin;
import org.processmining.framework.connections.ConnectionCannotBeObtained;
import org.processmining.framework.packages.UnknownPackageException;
import org.processmining.framework.packages.UnknownPackageTypeException;
import org.processmining.framework.packages.impl.CancelledException;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.models.graphbased.directed.petrinet.Petrinet;

public class DecomposedAlphaMiner implements DecomposedImplicitMiner {

	private static final String NAME = "Alpha Miner";

	public Petrinet mineImplicit(PluginContext context, XLog eventLog, DecomposedMinerParameters parameters)
			throws CancelledException, UnknownPackageTypeException, UnknownPackageException, ConnectionCannotBeObtained {
		Object[] objs = AlphaMinerPlugin.applyAlphaClassic(context, eventLog, parameters.getClassifier());
		return (Petrinet) objs[0];
	}

	public String getName() {
		return NAME;
	}

	public boolean requiresStartEndEvents() {
		return true;
	}
}
