package org.processmining.acceptingpetrinetminer.miners.impl;

import org.deckfour.xes.info.XLogInfo;
import org.deckfour.xes.info.XLogInfoFactory;
import org.deckfour.xes.model.XLog;
import org.processmining.acceptingpetrinetminer.miners.DecomposedImplicitMiner;
import org.processmining.acceptingpetrinetminer.miners.DecomposedMinerParameters;
import org.processmining.framework.connections.ConnectionCannotBeObtained;
import org.processmining.framework.packages.PackageManager;
import org.processmining.framework.packages.UnknownPackageException;
import org.processmining.framework.packages.UnknownPackageTypeException;
import org.processmining.framework.packages.impl.CancelledException;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.models.graphbased.directed.petrinet.Petrinet;
import org.processmining.models.heuristics.HeuristicsNet;
import org.processmining.plugins.heuristicsnet.miner.heuristics.miner.settings.HeuristicsMinerSettings;

public class DecomposedHeuristicsMiner implements DecomposedImplicitMiner {

	private static final String NAME = "Heuristics Miner";

	public Petrinet mineImplicit(PluginContext context, XLog eventLog, DecomposedMinerParameters parameters)
			throws CancelledException, UnknownPackageTypeException, UnknownPackageException, ConnectionCannotBeObtained {
		HeuristicsMinerSettings settings = new HeuristicsMinerSettings();
		settings.setClassifier(parameters.getClassifier());
		XLogInfo info = XLogInfoFactory.createLogInfo(eventLog, parameters.getClassifier());
		PackageManager.getInstance().findOrInstallPackages("HeuristicsMiner");
		HeuristicsNet hn = context.tryToFindOrConstructFirstNamedObject(HeuristicsNet.class,
				"Mine for a Heuristics Net using Heuristics Miner", null, null, eventLog, settings, info);
		Petrinet pn = context.tryToFindOrConstructFirstNamedObject(Petrinet.class, "Convert Heuristics net into Petri net",
				null, null, hn);
		return pn;
	}


	public String getName() {
		return NAME;
	}


	public boolean requiresStartEndEvents() {
		return false;
	}
}
