package org.processmining.acceptingpetrinetminer.miners.impl;

import java.util.HashSet;
import java.util.Set;

import org.processmining.causalactivitymatrixminer.miners.MatrixMiner;
import org.processmining.causalactivitymatrixminer.miners.impl.HAFMiniMatrixMiner;
import org.processmining.hybridilpminer.parameters.LPConstraintType;
import org.processmining.hybridilpminer.parameters.LPFilterType;
import org.processmining.hybridilpminer.parameters.NetClass;

public class DecomposedSequenceEncodingHybridILPMiner extends DecomposedAbstractHybridILPMiner {

	public String getName() {
		return "Hybrid Filtered ILP MIner (Sequence-Encoding)";
	}

	public Set<LPConstraintType> getConstraintsDisabled() {
		return new HashSet<>(NetClass.PT_NET.getRequiredConstraints());
	}

	public MatrixMiner getMiner() {
		return new HAFMiniMatrixMiner();
	}

	public LPFilterType getFilter() {
		return LPFilterType.SEQUENCE_ENCODING;
	}
}
