package org.processmining.acceptingpetrinetminer.parameters;

import org.deckfour.xes.classification.XEventClassifier;
import org.processmining.acceptingpetrinetminer.miners.DecomposedMinerManager;
import org.processmining.basicutils.parameters.impl.PluginParametersImpl;
import org.processmining.log.models.EventLogArray;
import org.processmining.log.parameters.ClassifierParameter;
import org.processmining.log.parameters.MinerParameter;
import org.processmining.log.utils.XUtils;

public class DiscoverAcceptingPetriNetArrayFromEventLogArrayParameters extends PluginParametersImpl implements ClassifierParameter, MinerParameter {

	private XEventClassifier classifier;
	private String miner;
	private boolean transitionBordered;
	private boolean removeGamma;

	public DiscoverAcceptingPetriNetArrayFromEventLogArrayParameters(EventLogArray logs) {
		setClassifier(XUtils.getDefaultClassifier(logs.getLog(0)));
		setMiner(DecomposedMinerManager.getInstance().getMiner(null).getName());
		setTransitionBordered(false);
		setRemoveGamma(false);
	}

	public DiscoverAcceptingPetriNetArrayFromEventLogArrayParameters(DiscoverAcceptingPetriNetArrayFromEventLogArrayParameters parameters) {
		setClassifier(parameters.getClassifier());
		setMiner(parameters.getMiner());
		setTransitionBordered(parameters.isTransitionBordered());
		setRemoveGamma(parameters.isRemoveGamma());
	}
	
	public boolean equals(Object object) {
		if (object instanceof DiscoverAcceptingPetriNetArrayFromEventLogArrayParameters) {
			DiscoverAcceptingPetriNetArrayFromEventLogArrayParameters parameters = (DiscoverAcceptingPetriNetArrayFromEventLogArrayParameters) object;
			return super.equals(parameters) && getClassifier().equals(parameters.getClassifier()) 
					&& getMiner().equals(parameters.getMiner())
					&& isTransitionBordered() == parameters.isTransitionBordered()
					&& isRemoveGamma() == parameters.isRemoveGamma();
		}
		return false;
	}

	public void setClassifier(XEventClassifier classifier) {
		this.classifier = classifier;
	}

	public XEventClassifier getClassifier() {
		return classifier;
	}

	public void setMiner(String miner) {
		this.miner = miner;
	}

	public String getMiner() {
		return miner;
	}

	public void setTransitionBordered(boolean transitionBordered) {
		this.transitionBordered = transitionBordered;
	}

	public boolean isTransitionBordered() {
		return transitionBordered;
	}

	public void setRemoveGamma(boolean removeGamma) {
		this.removeGamma = removeGamma;
	}

	public boolean isRemoveGamma() {
		return removeGamma;
	}
}
